
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class User_tooltipsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const user_tooltips = await db.user_tooltips.create(
            {
                id: data.id || undefined,
        
        tooltip_key: data.tooltip_key
        ||
        null
            ,
            
        dismissed: data.dismissed
        ||
        false
        
            ,
            
        dismissed_at: data.dismissed_at
        ||
        null
            ,
            
        experience_mode: data.experience_mode
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await user_tooltips.setUser( data.user || null, {
            transaction,
        });
        

        

        

        return user_tooltips;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const user_tooltipsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                tooltip_key: item.tooltip_key
            ||
            null
            ,
            
                dismissed: item.dismissed
            ||
            false
        
            ,
            
                dismissed_at: item.dismissed_at
            ||
            null
            ,
            
                experience_mode: item.experience_mode
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const user_tooltips = await db.user_tooltips.bulkCreate(user_tooltipsData, { transaction });

        // For each item created, replace relation files
        

        return user_tooltips;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const user_tooltips = await db.user_tooltips.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.tooltip_key !== undefined) updatePayload.tooltip_key = data.tooltip_key;
        
        
        if (data.dismissed !== undefined) updatePayload.dismissed = data.dismissed;
        
        
        if (data.dismissed_at !== undefined) updatePayload.dismissed_at = data.dismissed_at;
        
        
        if (data.experience_mode !== undefined) updatePayload.experience_mode = data.experience_mode;
        
        
        updatePayload.updatedById = currentUser.id;

        await user_tooltips.update(updatePayload, {transaction});

        
        
        if (data.user !== undefined) {
            await user_tooltips.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        

        
        

        

        return user_tooltips;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const user_tooltips = await db.user_tooltips.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of user_tooltips) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of user_tooltips) {
                await record.destroy({transaction});
            }
        });


        return user_tooltips;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const user_tooltips = await db.user_tooltips.findByPk(id, options);

        await user_tooltips.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await user_tooltips.destroy({
            transaction
        });

        return user_tooltips;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const user_tooltips = await db.user_tooltips.findOne(
            { where },
            { transaction },
        );

        if (!user_tooltips) {
            return user_tooltips;
        }

        const output = user_tooltips.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.user = await user_tooltips.getUser({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.tooltip_key) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'user_tooltips',
                        'tooltip_key',
                        filter.tooltip_key,
                    ),
                };
            }
            

            
            

            
            if (filter.dismissed_atRange) {
                const [start, end] = filter.dismissed_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    dismissed_at: {
                    ...where.dismissed_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    dismissed_at: {
                    ...where.dismissed_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.dismissed) {
                where = {
                    ...where,
                dismissed: filter.dismissed,
            };
            }
            
            if (filter.experience_mode) {
                where = {
                    ...where,
                experience_mode: filter.experience_mode,
            };
            }
            


      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.user_tooltips.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'user_tooltips',
                        'tooltip_key',
                        query,
                    ),
                ],
            };
        }

        const records = await db.user_tooltips.findAll({
            attributes: [ 'id', 'tooltip_key' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['tooltip_key', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.tooltip_key,
        }));
    }

    
};

